# This product is licensed under the GNU Lesser General Public License:
#
# ZipCodeTool  |  Copyright(C), 2004, Enfold Systems, LLC
#
# Enfold Systems, LLC
# 4500 Montrose Blvd., Suite D
# Houston, Texas 77006 USA
# p. +1 713.942.2377 | f. +1 832.201.8856
# www.enfoldsystems.com
# info@enfoldsystems.com
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# For a full copy of the license, please see the included 'LGPL.txt' file.

import gzip, os
from StringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.ZipCodeTool.zipcode_tool import ZipCode
from BTrees.IOBTree import IOBTree
from Products.ZipCodeTool.config import datadir, distance_ranges
distance_ranges.sort()
lines_per_zip = len(distance_ranges) + 1

def createZip(zip, lines):
    zipcode = int(zip)
    zip_ranges = []
    for line in lines:
        line = line.strip()
        zips = filter(None, line.split(', '))
        zip_ranges.append(zips)
    zip = ZipCode(zipcode, zip_ranges)
    return zip

def loadZips(self, filename='data.gz'):
    out = StringIO()
    ztool = getToolByName(self, 'portal_zipcode')
    if hasattr(ztool, '_storage'):
        del ztool._storage # remove the old zipcodes
    storage = IOBTree()
    filename = os.path.join(datadir, filename)
    datafile = gzip.open(filename, 'rb')
    row = 'start'
    count = 0
    while True:
        zip = datafile.readline()
        if zip == '': break
        lines = []
        for x in distance_ranges:
            lines.append(datafile.readline())
        zip = createZip(zip, lines)
        storage[int(zip.zip)] = zip
    ztool._storage = storage
    print >> out, 'Fin.'
    return out.getvalue()

